--    Copyright (C) 2004 by neuron                                          
--    aagaande@gmail.com                                             
--                                                                          
--    This program is free software; you can redistribute it and--or modify  
--    it under the terms of the GNU General Public License as published by  
--    the Free Software Foundation; either version 2 of the License, or     
--    (at your option) any later version.                                   
--                                                                          
--    This program is distributed in the hope that it will be useful,       
--    but WITHOUT ANY WARRANTY; without even the implied warranty of        
--    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         
--    GNU General Public License for more details.                          
--                                                                          
--    You should have received a copy of the GNU General Public License     
--    along with this program; if not, write to the                         
--    Free Software Foundation, Inc.,                                       
--    59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. 


--			TODO LIST:
-- Internal:
--		Cleanups
--				shorten variables a lot, remove the str/i crap
--				is it possible to make one format function that gets quest id's etc, and goes through everything?
--		Settings : Rename Tracked/Not Tracked to Visible/Hidden, easier to understand.
--      <Industrial> tip:  align the number of items needed and total for each point to the right

-- Graphical:
--		On clicking quest in tracker, show a custom quest details frame (whenever Kemayo makes that a module)
--		On indent multiline quest texts (for example goto) should the whole text be indented or just the start?
--		Better dragging (anchor or a few more pixels to drag from)
--		Anchor
--		Resize grip down in the right corner?
--		Max height?  Could make the whole frame ScrollFrame, and scroll it with middle mouse button (this also works nicly with draggong/anchor/resize grip, on unlock you drag the max size, on lock it resizes itself, but remembers max)
--		In tooltip show Reward Money/Spell/Items (maybe show the items you can use of the rewards as well?)
--		kemayo * r26245 FuBar_QuestsFu/QuestsFu.lua: FuBar_QuestsFu: Try to auto-highlight proper nouns and numbers in quest objective and description text. <-- really good idea.

-- Overriding blizzard:
--		On open blizzard questlog frame, warn about not using the old questlog.
--		When track quest using blizzard quest tracking function, warn about using builtin quest tracking.

-- Todo modules:
--			Quest statistics, on tooltip show % chance of a mob dropping quest item (store this db in memory, remove when quest finished).

nQuestLog = AceLibrary("AceAddon-2.0"):new(
	"AceHook-2.1", 
    "AceConsole-2.0", 
    "AceDB-2.0", 
    "AceEvent-2.0",
    "AceModuleCore-2.0",
    "FuBarPlugin-2.0")
    
local quixote = AceLibrary("Quixote-1.0")
local crayon = AceLibrary("Crayon-2.0")
    
nQuestLog.defaultPosition = "LEFT"
nQuestLog.hasIcon = true
nQuestLog.defaultMinimapPosition = 250

function nQuestLog:ToggleVisible(open)
	if (open) then
		self.db.char["visible"] = true
		nQuestLogFrame:SetWidth(self.db.profile.width)
		self:SetPosition()
		self:RefreshTracker()
	else
		self.db.char["visible"] = false
		nQuestLogFrame:Hide()
	end
end

function nQuestLog:RefreshMenu()
	local lastPrintedZone = {}
	local menuOrder = 10
	
	self.mainMenu.args["Quests"] = {
		type = 'group',
		name = 'Watched Quests',
		order = 80,
		desc = 'Listing all quests',
		args = {}
	}
	
	local strTrackingDefault = "Hide completed"
	if (self.db.profile.hideAllObjectives) then
		strTrackingDefault = "Hidden"
	elseif (not self.db.profile.hideCompletedObjectives) then
		strTrackingDefault = "Shown"
	end
	
	if (self.db.profile.smartQuestTracking) then
		strTrackingDefault = "Smart"
	end
	
	self.mainMenu.args["Objectives"] = {
		type = 'group',
		name ='Show/Hide objectives',
		order = 85,
		desc='Listing all watched quests',
		args = {
			headerTop = {
				type = 'header',
				name = 'Default : ' .. strTrackingDefault,
				order = 1,
				desc = 'Default quest objective tracking',
			},
			reset = {
				type = 'execute',
				name = '  Reset manually watched objectives',
				order = 2,
				desc = 'Reset manually watched objectives',
				func = function()
					self.db.char.watchedObjectives = {}
					nQuestLog:Refresh()
				end,
			}
		}
	}
	
	local function AddToMenu(data,strTitle,strFancyTitle,strZone,strDescription)
		local strMenuName = data.Menu
		if (lastPrintedZone[strMenuName] ~= strZone) then
			self.mainMenu.args[strMenuName].args[strZone] = {
				type = 'toggle',
				name = self:Format_QuestZone(strZone),
				order = menuOrder,
				desc = 'Zone ' .. strZone,
				get = function()
					if (self.db.char.hiddenZones[strZone]) then
						return false
					end
					return true
				end,
				set = function(v)
					if (not v) then
						self.db.char.hiddenZones[strZone] = true
					else
						self.db.char.hiddenZones[strZone] = nil
					end
					self:Refresh()
				end
			}
			lastPrintedZone[strMenuName] = strZone
			menuOrder = menuOrder + 1
		end


		self.mainMenu.args[strMenuName].args[strTitle] = {
	            type = 'toggle',
	            name = strFancyTitle,
	            desc = strDescription,
	            order = menuOrder,
	            get = data.get,
	            set = data.set,
		}
	end
	
	
	
	
	-- Scan all quests
	for _, tmp_Zone in quixote:IterZones() do
		for _,iQuestId in quixote:QuestsByZone(tmp_Zone) do
			-- TODO, clear up the variables we dont use and remove them.
			local strTitle, iLevel, strTag, strObjective, iComplete, iObjectives, strZone = quixote:GetQuestById(iQuestId)
			local strDescription = strObjective -- TODO make this use same function as ShowTooltip or something like that?  It'd be much prettier.
					
			-- Scan the objectives to get numbers of quest items we want:
			local iTotalGot, iTotalNeeded = 0,0
			for i=1,iObjectives do
				local _, strType, iGot, iNeeded,isDone = quixote:GetQuestStatusById(iQuestId, i)
				if (strType == "reputation") then iNeeded = 1	iGot = 0	if (isDone) then iGot = 1 end end
				iTotalGot = iTotalGot + iGot
				iTotalNeeded = iTotalNeeded + iNeeded
			end
			
			-- Then the quest:
			local strFancyTitle = self:Format_QuestTitle(strTitle,iLevel,strTag,iTotalGot,iTotalNeeded,iComplete)
			AddToMenu({Menu="Quests",
					get = function()
						if (self.db.char.watchedQuests[strTitle]) then
							return true
						end
						return false
		            end,
		            set = function(v)
		            	if (v) then
		            		self.db.char.watchedQuests[strTitle] = true
		            	else
		            		self.db.char.watchedQuests[strTitle] = nil
		            	end
		            	nQuestLog:Refresh()
		            end,},strTitle,strFancyTitle,strZone,strDescription)

			
			if (self.db.char.watchedQuests[strTitle]) then
				AddToMenu({Menu="Objectives",
			            get = function()
			            	return nQuestLog:ShouldShowObjective(strTitle,iTotalGot,iTotalNeeded)
			            end,
			            set = function(v)
			            	if (v) then
			            		self.db.char.watchedObjectives[strTitle] = true
			            	else
			            		self.db.char.watchedObjectives[strTitle] = false
			            	end
			            	nQuestLog:Refresh()
			            end,
				},strTitle,strFancyTitle,strZone,strDescription)
			end
			
			menuOrder = menuOrder + 1
		end
	end
end

function nQuestLog:SetPosition()
	nQuestLogFrame:ClearAllPoints()
	if (not self.db.profile["trackerGrowUp"]) then
		-- Grown down
		nQuestLogFrame:SetPoint("TOPLEFT",UIParent, "BOTTOMLEFT",self.db.profile["positionLeft"],self.db.profile["positionTop"])
	else
		-- Grow up
		nQuestLogFrame:SetPoint("BOTTOMLEFT",UIParent, "BOTTOMLEFT",self.db.profile["positionLeft"],self.db.profile["positionBottom"])
	end
end

function nQuestLog:SavePosition()
	self.db.profile["positionBottom"] = nQuestLogFrame:GetBottom()
	self.db.profile["positionLeft"] = nQuestLogFrame:GetLeft()
	self.db.profile["positionTop"] = nQuestLogFrame:GetTop()
end

function nQuestLog:ShowZoneToolTip(strZone)
	if (self.db.profile["tooltipAnchor"] == "DEFAULT") then
		GameTooltip_SetDefaultAnchor(GameTooltip, nQuestLogFrame)
	else
		GameTooltip:SetOwner(nQuestLogFrame,self.db.profile["tooltipAnchor"])
	end
	
	--Set Title text
	GameTooltip:SetText(strZone)
	
	local function showZoneQuests(showHidden)
		local quests = {}
		local nQuests = 0
		for _,iQuestId in quixote:QuestsByZone(strZone) do
			local strTitle, iLevel, strTag, strObjective, iComplete, iObjectives, strZone = quixote:GetQuestById(iQuestId)

			if (showHidden and not self.db.char.watchedQuests[strTitle]) or (not showHidden and self.db.char.watchedQuests[strTitle]) then
				local objectives,iTotalGot,iTotalNeeded = self:Format_QuestObjectives(strTitle,iObjectives,strObjective,iQuestId,true)
				strTitle = self:Format_QuestTitle(strTitle,iLevel,strTag,iTotalGot,iTotalNeeded,iComplete)
				nQuests = nQuests + 1
				quests[strTitle] = true
			end
		end
		return quests,nQuests
	end
	
	local function printQuests(quests)
		for name in pairs(quests) do
			GameTooltip:AddLine(name,1,0.5,0.5,0)
		end
	end
	
	if (self.db.char.hiddenZones[strZone]) then
		GameTooltip:AddLine("  -  Zone hidden",1,1,1,0)
	end
	
	local quests,nQuests = showZoneQuests(false)
	if (nQuests > 0) then
		GameTooltip:AddLine("Tracked quests (" .. nQuests .. ")",1,0.5,0.5,0)
		printQuests(quests)
	end
	
	local quests,nQuests = showZoneQuests(true)
	if (nQuests > 0) then
		GameTooltip:AddLine("Hidden quests (" .. nQuests .. ")",1,0.5,0.5,0)
		printQuests(quests)
	end
	
	GameTooltip:AddLine("\nHint : Right click to show/hide quests\n          Alt + rightclick to show all zones",1,1,1,0)
	
	GameTooltip:Show()
end

function nQuestLog:ShowQuestToolTip(iQuestId)
	-- TODO : layout options, ShowObjectives,ShowAll,ShowShort?
	-- TODO : maybe for example show all quest data on modifier key?
	local strTitle, iLevel, strTag, strObjective, _, iObjectives, strZone = quixote:GetQuestById(iQuestId)
	if (strTitle == nil) then
		return
	end

	

	if (self.db.profile["tooltipAnchor"] == "DEFAULT") then
		GameTooltip_SetDefaultAnchor(GameTooltip, nQuestLogFrame)
	else
		GameTooltip:SetOwner(nQuestLogFrame,self.db.profile["tooltipAnchor"])
	end


	
	--Set Title text
	GameTooltip:SetText(strTitle)
	
	--Add objective description
	GameTooltip:AddLine(crayon:Copper(strObjective),0.5,0.5,0.5,1)
	
	--Add progress
	local objectives,iTotalGot,iTotalNeeded = self:Format_QuestObjectives(strTitle,iObjectives,strObjective,iQuestId,true)
	if (iTotalNeeded > 0) then
		local color = crayon:GetThresholdHexColor(iTotalGot / iTotalNeeded)
		objectives = "\nTotal : " .. crayon:Colorize(color,iTotalGot .. "/" .. iTotalNeeded) .. objectives
	end
	GameTooltip:AddLine(objectives,1,1,1,0)
	
	--Add who in party has the quest:
	local ipartyMembers = GetNumPartyMembers()
	if (ipartyMembers > 0) then
		GameTooltip:AddLine("\n",1,1,1,0)
		for i = 1,ipartyMembers do
			if (IsUnitOnQuest(iQuestId, "party"..i)) then
				-- Party member is on the quest
				local strName = UnitName("party" .. i)
				
				-- Lets see if we can get quest progress too:
				local iPartyTotal = 0
				if (iObjectives > 0) then
					for i=1,iObjectives do
						local strDesc,strType, iGot, iNeeded = quixote:GetQuestStatusById(iQuestId, i)
						local iPartyGot = quixote:GetPartyQuestStatus(strName, iQuestId, strDesc)
						if (iPartyGot) then
							if (strType == "reputation") then 
								if (iNeeded == iPartyGot) then
									iPartyTotal = iPartyTotal + 1
								end
							else
								iPartyTotal = iPartyTotal + iPartyGot
							end
						end
					end
					local color = crayon:GetThresholdHexColor(iPartyTotal / iTotalNeeded)
					if (iPartyTotal == 0) then
						iPartyTotal = "?"
					end
					strName = strName .. " " .. crayon:Colorize(color,iPartyTotal .. "/" .. iTotalNeeded)
				end
				GameTooltip:AddLine(strName,0,1,0,0)
			else
				-- Party member is not on the quest
				GameTooltip:AddLine(UnitName("party" .. i),1,0,0,0)
			end
		end
	end
	
	GameTooltip:AddLine("\nHint : Alt click to show/hide objectives",1,1,1,0)
	GameTooltip:Show()
end

function nQuestLog:RefreshTracker()
	-- Refreshes all tracker stuff
	
	-- Local functions
	function RefreshBackdrop()
		nQuestLogFrame:SetBackdrop({
			bgFile = "Interface/Tooltips/UI-Tooltip-Background",
			edgeFile = "Interface/Tooltips/UI-Tooltip-Border", 
				tile=true, 
				tileSize=16,
				edgeSize=16,
			insets = { left=5, right=5, top=5, bottom=5}
		})
		local cBorderColor = self:GetColor("trackerBorderColor")
		local cBackgroundColor = self:GetColor("trackerBackgroundColor")
		nQuestLogFrame:SetBackdropBorderColor(cBorderColor.r / 255, cBorderColor.g / 255, cBorderColor.b / 255, cBorderColor.a)
		nQuestLogFrame:SetBackdropColor(cBackgroundColor.r / 255, cBackgroundColor.g / 255, cBackgroundColor.b / 255, cBackgroundColor.a)
	end


	function RefreshFontSize()
		for i=1,MAX_QUESTS * 2,1 do
			local frameText = getglobal("nQuestLogButton" .. i .. "Text")
			local fontName, fontHeight, fontFlags = frameText:GetFont()
			frameText:SetFont(fontName,self.db.profile.fontSize,fontFlags)
		end
	end

	RefreshBackdrop()
	RefreshFontSize()
	nQuestHeaderText:SetText(self:Colorize("nQuestLog","trackerHeader"))
	self:Refresh()
end


function nQuestLog:Refresh()
	if (not self.db.char["visible"] or self.refreshHold) then
		return
	end
	
	-- Local variables
	local iFrameHeight = 0
	local strLastPrintedZone = ""
	local iQuestNumber = 1	-- Temporary, used to get frame data.
	local bLastFrameQuest = false -- This is used for padding, can be 1
	local strTitle, iLevel, strTag, strObjective, iComplete, iObjectives, strZone
	
	local function HideButtons()
		-- Hide all QuestInfo we're not showing:
		for i=iQuestNumber,MAX_QUESTS * 2,1 do
			local frame = getglobal("nQuestLogButton" .. i)
			frame:Hide()
		end
	end
	
	local function SetFrameText(strText,iQuestId,strZone)
		-- Shows + sets text on a new frame
		local frame = getglobal("nQuestLogButton" .. iQuestNumber)
		local frameText = getglobal("nQuestLogButton" .. iQuestNumber .. "Text")
		local isHighlight
		if (iQuestId == nil) then
			-- Calculate how many quests are visible/not visible for this zone.
			local iAllQuests = 0
			local iVisibleQuests = 0
			for _,iQuestId in quixote:QuestsByZone(strZone) do
				local strQuestTitle = quixote:GetQuestById(iQuestId)
				if (self.db.char.hiddenZones[strZone] and self.db.profile.showQuestHighlight) then
					-- Zone is hidden, lets see if we should show highlight for it:
					if self.db.profile.hideAllObjectives and self:IsModuleEnabled("SmartVisibility") and self:GetModule("SmartVisibility"):ShouldShowObjective(strQuestTitle) then	
						-- We're showing objectives here, and hideAllObjectives is true, we should highlight
						isHighlight = true
					elseif (self.highlightList[strQuestTitle]) then
						-- We have a highlighted quest in the hidden zone, highlight zone
						isHighlight = true
					end
				end
				iAllQuests = iAllQuests + 1
				if (self.db.char.watchedQuests[strQuestTitle]) then
					iVisibleQuests = iVisibleQuests + 1
				end
			end
		
		
			if (self.db.char.hiddenZones[strZone]) then
				strText = "+" .. strText
			else
				strText = "-" .. strText
			end

			if (self.db.profile.showZoneVisibleStatus) then
				if (self.db.char.hiddenZones[strZone]) then
					strText = strText .. " (" .. iAllQuests .. " hidden)"
				else
					strText = strText .. " (" .. iVisibleQuests .. "/" .. iAllQuests .. " visible)"
				end
			elseif(iVisibleQuests < iAllQuests and not self.db.char.hiddenZones[strZone]) then
				strText = strText .. " *"
			end
		else
			-- highlight quest
			isHighlight = self.highlightList[strTitle]
		end
		frameText:SetText(strText)
		
		-- Padding
		if (iQuestNumber > 1) then
			local parent = getglobal("nQuestLogButton" .. iQuestNumber - 1)
			
			local padding = self.db.profile.questPadding
			if (iQuestId ~= nil) then
				if (bLastFrameQuest) then
					padding = self.db.profile.questPadding
				else
					padding = 0
				end
				bLastFrameQuest = true
			else
				padding = self.db.profile.zonePadding
				bLastFrameQuest = false
			end
			
			frame:SetPoint("TOPLEFT",parent,"BOTTOMLEFT",0,-padding)
			iFrameHeight = iFrameHeight + padding
		end


		frameText:SetWidth(nQuestLogFrame:GetWidth() - 12) -- -10 = adjust for 5pixel border., and 2 for good measure (no seriously, it wraps wrong without it)
		frame:SetWidth(frameText:GetWidth())
		frame:SetHeight(frameText:GetHeight())
		iFrameHeight = iFrameHeight + frame:GetHeight()
		
		frame:Show()
		if (isHighlight) then
			--self:Print("On  : " .. strText)
			local color = self:GetColor("questHighlight")
			frame:SetBackdropColor(color.r / 255,color.g / 255,color.b / 255,color.a)
		else
			--self:Print("Off : " .. strText)
			frame:SetBackdropColor(0,0,0,0)
		end
		frame.strZone = strZone
		frame.iQuestId = iQuestId
		iQuestNumber = iQuestNumber + 1
	end
	

	local function TrackQuest(iQuestId)
		local strObjectives, iTotalGot, iTotalNeeded = self:Format_QuestObjectives(strTitle,iObjectives,strObjective,iQuestId)
		local strTitle = self:Format_QuestTitle(strTitle,iLevel,strTag,iTotalGot,iTotalNeeded,iComplete)
		SetFrameText(strTitle .. strObjectives,iQuestId,strZone)
	end
	
	
	
	-- Scan all quests
	for _, tmp_Zone in quixote:IterZones() do
		if (self.db.char.hiddenZones[tmp_Zone]) then
			-- Zone for this quest is hidden
			if (self.db.profile.showEmptyZones) then
				SetFrameText(self:Format_QuestZone(tmp_Zone),nil,tmp_Zone)
			else
				-- Zone is hidden and we should not show empty zones, lets see if we have any quests tracked here.
				for _,iQuestId in quixote:QuestsByZone(tmp_Zone) do
					strTitle = quixote:GetQuestById(iQuestId)
					if (self.db.char.watchedQuests[strTitle]) then
						-- Yes we do, lets show the zone
						SetFrameText(self:Format_QuestZone(tmp_Zone),nil,tmp_Zone)
						break
					end
				end -- for
			end -- if showEmptyZones
		else
			-- Zone for this quest is not hidden
			SetFrameText(self:Format_QuestZone(tmp_Zone),nil,tmp_Zone)
			for _,iQuestId in quixote:QuestsByZone(tmp_Zone) do
				-- TODO, clear up the variables we dont use and remove them.
				strTitle, iLevel, strTag, strObjective, iComplete, iObjectives, strZone = quixote:GetQuestById(iQuestId)
				if (self.db.char.watchedQuests[strTitle]) then
					-- OK, we found a quest, lets add it.
					TrackQuest(iQuestId)
				end
			end
		end
	end
	
	-- Hide all QuestInfo we're not showing:
	HideButtons()
	if (nQuestHeader:IsVisible()) then
		iFrameHeight = iFrameHeight + nQuestHeader:GetHeight()
	end
	
	nQuestLogFrame:SetHeight(iFrameHeight + 10)

	if (iFrameHeight == 0) then
		nQuestLogFrame:Hide()
	else	
		nQuestLogFrame:Show()
		self:SavePosition()
	end
end

function nQuestLog:OnEnable()
	self:CreateFrames()

	-- This is a list of the zones/quests that should be highlighted.
	self.highlightList = {}
	
	self.refreshHold = true
	
	if (self.db.profile["positionBottom"] == -1 or self.db.profile["profilepositionLeft"] == -1 or self.db.profile["profilepositionTop"] == -1) then
		nQuestLogFrame:ClearAllPoints()
		nQuestLogFrame:SetPoint("CENTER",0,0)
		self:SavePosition()
	end
	
	--Register Quixote Events:
	self:RegisterEvent("Quixote_Quest_Gained", "OnQuest_Gained")
	self:RegisterEvent("Quixote_Quest_Lost", "OnQuest_Lost")
	self:RegisterEvent("Quixote_Leaderboard_Update", "OnQuest_Leaderboard_Update")
	self:RegisterEvent("Quixote_Update", "Refresh")
	self:RegisterEvent("Quixote_Ready", "OnQuestLog_Ready",true)
	
	-- Initiate modules
	self:LoadModules()
	
	self:UpdateEvents()
	self:MakeSettingsMenu(self.mainMenu.args["settings"])
end


